import  os, socket, re
try:
    import synthstate, conf, OSC
except ImportError:
    dir = os.path.dirname(__file__)
    import sys
    sys.path.append(dir)
    sys.path.append(os.path.join(dir, "lib"))
    import synthstate, conf, OSC
# make sure we have up-to-date configuration... at the expense of slowness.
#reload(conf); 

from twisted.web import resource

class MahResource(resource.Resource):
    def render_GET(self, request):
        sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        for field, formvalues in request.args.iteritems():
            #-------- safety checks
            # fail soft for unknown fields
            values = formvalues[0]
            if field not in conf.element_names:
                continue
            try:
                numVals = [toNum(v) for v in values.split(',')]
            except (IndexError, KeyError, OverflowError):
                continue
            if len(numVals) > 256:
                continue

            #-------- Set state in memory, send to OSC
            if numVals:
                synthstate.state[field] = numVals
                m = OSC.Message( '/%s' % field, *numVals )
                sock.sendto(m.get_packet(), (conf.osc_host, conf.osc_port))

        #------- Return data in JSON format
        objstrs = []
        for key, vals in synthstate.state.iteritems():
            if len(vals) > 1:
                objstr = '"%s": [%s]'
            else:
                objstr = '"%s": %s'
            objstrs.append(objstr % (key, ",".join( [ str(v) for v in vals ] )))

        json = "{ %s }" % ", ".join(objstrs)
        return json
    
    render_POST = render_GET

def toNum(val):
    try:
        i = int(val)
    except ValueError:
        i = 0

    try:
        f = float(val)
    except ValueError:
        return 0

    if f != i:
        return f
    return i

resource = MahResource()
